/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package cicsl.validacioncierres;

import cicsl.log4j.logCola.LogProceso;
import cicsl.models.worker.util.Ini;
import cicsl.pojos.CchValidacion;
import cicsl.pojos.CchValidacionId;
import cicsl.pojos.Flaghorvar;
import cicsl.pojos.RatrLineasValidacion;
import cicsl.pojos.RatrLineasValidacionId;
import cicsl.pojos.RatrValidacion;
import cicsl.pojos.Resumenes;
import cicsl.pojos.ResumenesLineas;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.List;
import java.util.Properties;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.jms.JMSException;
import javax.jms.ObjectMessage;
import javax.jms.Queue;
import javax.jms.QueueConnection;
import javax.jms.QueueConnectionFactory;
import javax.jms.QueueSender;
import javax.jms.QueueSession;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.hibernate.SQLQuery;
import org.hibernate.Session;
import org.hibernate.Transaction;

/**
 *
 * @author fsainzm
 */
public class Inicio {

    private static QueueConnection conn;
    private static QueueSession session;
    private static Queue cola;
    private static InitialContext iniCtx;
    private static String VERSION = "Validacion_Cierres_PM_ATR CDTI ATR v1.0";
    private int contadorProcesados;
    private Log logger = LogFactory.getFactory().getInstance(Inicio.class);

//		Logger.getLogger(Inicio.class);
    public static void main(String[] args) {
        new Inicio().hazTarea();
    }

    /**
     * Conecta a la cola
     */
    public void conectaCola() {
        try {
            Properties props = new Properties();
            props.setProperty("java.naming.factory.initial",
                    "org.jnp.interfaces.NamingContextFactory");
            props.setProperty("java.naming.provider.url", "192.168.1.168");
            props.setProperty("java.naming.factory.url.pkgs", "org.jboss.naming");
            iniCtx = new InitialContext(props);
            QueueConnectionFactory qcf = (QueueConnectionFactory) iniCtx.lookup("ConnectionFactory");
            conn = qcf.createQueueConnection();
            session = conn.createQueueSession(false,
                    QueueSession.AUTO_ACKNOWLEDGE);
            conn.start();
        } catch (Exception ex) {
            ex.printStackTrace();
            System.exit(-1);
        }
    }

    /**
     *
     * @param i
     * @return
     */
    public void hazTarea() {
        new ShutdownMonitor();
        logger.info("Descargador BBDD Iniciado");
        LogProceso.inicioProceso(VERSION, Ini.getPropiedades());
        conectaCola();
        try {
            try {
                Queue q=(Queue) iniCtx.lookup("queue/Cola_Consumos");
                QueueSender qs = session.createSender(q);
                for (int e=0;e<10;e++){
                for (int i=0;i<22;i++){
                    ObjectMessage om = session.createObjectMessage(new String(""+i));
                    om.setStringProperty("_HQ_LVQ_NAME", "2010060120100631AE.1923.CAN.CS"+i);
                    System.out.println("Mando "+ i+"2010060120100631AE.1923.CAN.CS");
                    qs.send(om);
                        try {
                            Thread.sleep(1000);
                        } catch (InterruptedException ex) {
                        }
                }
                }
            } catch (JMSException ex) {
                Logger.getLogger(Inicio.class.getName()).log(Level.SEVERE, null, ex);
            }
        } catch (NamingException ex) {
            Logger.getLogger(Inicio.class.getName()).log(Level.SEVERE, null, ex);
        }


    }

    class ShutdownMonitor implements Runnable {

        public ShutdownMonitor() {
            Thread shutdownThread = new Thread(this);
            Runtime.getRuntime().addShutdownHook(shutdownThread);
        }

        public void run() {
            try {
                session.close();
                conn.close();
            } catch (JMSException ex) {
                logger.error("Error cerrando conexiones");
            }
            logger.info("Descargando objetos restantes a DB");
            logger.info("Finalizado Proceso Descargador de cola a DB correctamente");
            LogProceso.resumenProceso(VERSION, contadorProcesados);
            LogProceso.finProceso(VERSION);
        }
    }
}
